
package eu.dnetlib.dhp.oa.graph.dump.gcat;

import java.io.*;
import java.util.zip.GZIPInputStream;
import java.util.zip.ZipEntry;
import java.util.zip.ZipInputStream;

import org.apache.commons.io.IOUtils;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.hadoop.conf.Configuration;
import org.apache.hadoop.fs.*;
import org.apache.http.HttpStatus;

import eu.dnetlib.dhp.application.ArgumentApplicationParser;

public class SendToCatalogue implements Serializable {

	private static final Log log = LogFactory.getLog(SendToCatalogue.class);

	public static void main(final String[] args) throws Exception {
		final ArgumentApplicationParser parser = new ArgumentApplicationParser(
			IOUtils
				.toString(
					SendToCatalogue.class
						.getResourceAsStream(
							"/eu/dnetlib/dhp/oa/graph/gcat/catalogue_parameters.json")));

		parser.parseArgument(args);

		final String access_token = parser.get("gcattoken");
		final String hdfsPath = parser.get("hdfsPath");
		final String hdfsNameNode = parser.get("hdfsNameNode");
		final String gcatBaseUrl = parser.get("gcatBaseUrl");

		Configuration conf = new Configuration();
		conf.set("fs.defaultFS", hdfsNameNode);

		FileSystem fileSystem = FileSystem.get(conf);

		RemoteIterator<LocatedFileStatus> fileStatusListIterator = fileSystem
			.listFiles(
				new Path(hdfsPath), true);
		GCatAPIClient gCatAPIClient = new GCatAPIClient();
		gCatAPIClient.setApplicationToken(access_token);
		gCatAPIClient.setGcatBaseURL(gcatBaseUrl);
		int purged = gCatAPIClient.purgeAll();
		log.info("purged: " + purged);
		while (fileStatusListIterator.hasNext()) {
			LocatedFileStatus fileStatus = fileStatusListIterator.next();

			Path p = fileStatus.getPath();
			String p_string = p.toString();
			if (!p_string.endsWith("_SUCCESS")) {
				// String tmp = p_string.substring(0, p_string.lastIndexOf("/"));
				// String name = tmp.substring(tmp.lastIndexOf("/") + 1);
//				log.info("Copying information for : " + name);
//				fileSystem.copyToLocalFile(p, new Path("/tmp/" + name));

				// try {
				// InputStream in = new GZIPInputStream(new FileInputStream("/tmp/" + name));

//					BufferedReader reader = new BufferedReader(
//						new InputStreamReader(in));
				FSDataInputStream in = fileSystem.open(p);

				GZIPInputStream gis = new GZIPInputStream(in);

				BufferedReader reader = new BufferedReader(new InputStreamReader(gis));
				String line;
				while ((line = reader.readLine()) != null) {
					try {
						gCatAPIClient.publish(line);
					} catch (Exception e) {
						log.error("ERROR_FOR " + line);
					}

				}
				reader.close();
				// in.close();

				// } finally {
//					log.info("deleting information for: " + name);
//					File f = new File("/tmp/" + name);
//					if (f.exists()) {
//						f.delete();
				// }

			}
		}

	}

}

//}
